// GENERATED CODE - edits may be overwritten
import java.io.IOException;
import java.net.Socket;

import dk.vajhoej.record.VAXFloatUtil;
import dk.vajhoej.vms.tig.server.ServerSingleThreaded;
import dk.vajhoej.vms.tig.shared.Connection;

import static dk.vajhoej.vms.call.VMS.*;

public class DemovServer extends ServerSingleThreaded {
    @Override
    public int getPort() {
        return 12347;
    }
    @Override
    public void process(Socket s) throws IOException {
        Connection con = new Connection(s);
        con.recv();
        String target = con.getString();
        if(target.equals("f_check")) {
            int v = con.getInt();
            v = VAXFloatUtil.s2f(v);
            LongWord vwrap = new LongWord(v);
            int retval = call("demov", "f_check"
                                     , pass(vwrap).byReference().readWrite()
                             );
            v = vwrap.getValue();
            con.prep();
            con.putInt(retval);
            v = VAXFloatUtil.f2s(v);
            con.putInt(v);
        }
        if(target.equals("d_check")) {
            long v = con.getLong();
            v = VAXFloatUtil.t2d(v);
            QuadWord vwrap = new QuadWord(v);
            int retval = call("demov", "d_check"
                                     , pass(vwrap).byReference().readWrite()
                             );
            v = vwrap.getValue();
            con.prep();
            con.putInt(retval);
            v = VAXFloatUtil.d2t(v);
            con.putLong(v);
        }
        if(target.equals("g_check")) {
            long v = con.getLong();
            v = VAXFloatUtil.t2g(v);
            QuadWord vwrap = new QuadWord(v);
            int retval = call("demov", "g_check"
                                     , pass(vwrap).byReference().readWrite()
                             );
            v = vwrap.getValue();
            con.prep();
            con.putInt(retval);
            v = VAXFloatUtil.g2t(v);
            con.putLong(v);
        }
        if(target.equals("s_check")) {
            float v = con.getFloat();
            SFloat vwrap = new SFloat(v);
            int retval = call("demov", "s_check"
                                     , pass(vwrap).byReference().readWrite()
                             );
            v = vwrap.getValue();
            con.prep();
            con.putInt(retval);
            con.putFloat(v);
        }
        if(target.equals("t_check")) {
            double v = con.getDouble();
            TFloat vwrap = new TFloat(v);
            int retval = call("demov", "t_check"
                                     , pass(vwrap).byReference().readWrite()
                             );
            v = vwrap.getValue();
            con.prep();
            con.putInt(retval);
            con.putDouble(v);
        }
        con.send();
    }
    public static void main(String[] args) throws IOException {
         (new DemovServer()).run();
    }
}
